#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>
#include "loader.h"
#include "g320x200.h"


#define JUGADOR         0x01
#define REY             0x11
#define REINA           0x12

#define MUEVE           0x80
#define PROFUNDIDAD     1

// #define MAX(a,b)        (a>b) ? a : b
// #define MIN(a,b)        (a<b) ? a : b


int desp[8][2];
int ultima[5];
int deb;
char *pantalla, *jugador, *reina , *rey, *paleta, *fuente;

char pieza (char **, int, int, int, int);
int jaque (char **);
int mueve (char **, int, int, int, int, int);
void init (char **);
void redraw (char **);
int direccion (int, int, int, int);
int jugar(char **);
int mover_jugador (char **);
int mover_maquina (char **, int);
int puntua (char **);
int distancia (char **, char);
int mate (char **);
void extractimg (char *, char *, int, int, int, int);
void vprintxyf(char *, char *, int, int, char *, int);


main() {
   int i, j;
   char **tablero;

   randomize();

   tablero=(char **) malloc(8*sizeof(char *));
   for (i=0;i<8;i++)
      if ((tablero[i]=(char *)malloc(8))==NULL) printf ("Unallocated");

   desp[0][0]=0; desp[0][1]=-1;
   desp[1][0]=1; desp[1][1]=-1;
   desp[2][0]=1; desp[2][1]=0;
   desp[3][0]=1; desp[3][1]=1;
   desp[4][0]=0; desp[4][1]=1;
   desp[5][0]=-1; desp[5][1]=1;
   desp[6][0]=-1; desp[6][1]=0;
   desp[7][0]=-1; desp[7][1]=-1;
   ultima[3]=0; ultima[2]=0; ultima[1]=0;


   do {
      init(tablero);
   } while (jaque(tablero));


   if (!(pantalla=(char *)malloc(64000))) {printf ("Sin memoria para el back-buffer");return 0;}
   if (!(reina=(char *)malloc(324))) {printf ("Sin memoria para la reina");return 0;}
   if (!(rey=(char *)malloc(324))) {printf ("Sin memoria para el rey");return 0;}
   if (!(jugador=(char *)malloc(324))) {printf ("Sin memoria para el jugador");return 0;}
   if (!(paleta=(char *)malloc(768))) {printf ("Sin memoria para la paleta"); return 0;}
   if (!(fuente=(char *)malloc(2048))) {printf ("Sin memoria para la fuente"); return 0;}

   if (!loadbmp("piezas.bmp",pantalla,paleta)) {printf ("No se ha podido cargar piezas.bmp!!"); return 0;}
   if (!loadfnt("estandar.fnt",fuente)) {printf ("No se ha podido cargar estandar.fnt!!"); return 0;}
   extractimg (pantalla, reina, 0,0,20,16);
   extractimg (pantalla, rey, 20,0,20,16);
   extractimg (pantalla, jugador, 40,0,20,16);
   
   asm {
      mov ax, 0x0013
      int 10h
   }
   setpalette(paleta);

   //_setcursortype(_NOCURSOR);

   jugar(tablero);

   //textcolor(7);
   //_setcursortype(_NORMALCURSOR);
   //clrscr();
   
   asm {
      mov ax, 0x0003
      int 10h
   }
   printf ("X");
   return 0;
}


int mueve (char **tablero, int ox, int oy, int dx, int dy, int fake) {
   int tmpx, tmpy, movim, fin, dist;
   char pact, pant;  //piezas actual y anterior

   if (dx<0 || dx>7 || dy<0 || dx>7) return 0;
   pact=tablero[ox][oy];
   dist= (abs(dx-ox)>abs(dy-oy)) ? abs(dx-ox) : abs(dy-oy);
   movim=direccion(ox, oy, dx, dy);
   if (movim!=-1) {
      tmpx=ox; tmpy=oy;
      fin=0;
      while (!fin) {
         tmpx+=desp[movim][0];
         tmpy+=desp[movim][1];
         if (tmpx>7 || tmpx<0 || tmpy>7 || tmpy<0) fin=1;
         else if (((pact & 0x10)==(tablero[tmpx][tmpy] & 0x10)) && tablero[tmpx][tmpy]) fin=1;
         else if (tmpx==dx && tmpy==dy) fin=2;
      }
      if (fin==2) {
         switch (pact & 0x0F) {
            case 0x01:
               if (dist==1) fin=0;
            break;
            case 0x02:
               fin=0;
            break;
         }
         if (!fin) {
            pant=tablero[dx][dy];
            tablero[dx][dy]=pact;
            tablero[ox][oy]=0;
            if (jaque(tablero) > ((pact & 0x10) >>4 )) {
               tablero[dx][dy]=pant;
               tablero[ox][oy]=pact;
               return 0;
            }
            if (fake) {
               tablero[dx][dy]=pant;
               tablero[ox][oy]=pact;
            }
            return 1;
         }
      }
      else return 0;   // choque o fuera de tablero
   }
   printf ("Invalid");
   return 0;  // movimiento invalido
}


int jaque (char **tablero) {
   int i, x, y, pos, jaque;

   jaque=0; x=0; y=0;
   while (y<8) {
      if (tablero[x][y]) {
         switch (tablero[x][y]) {
            case 0x11:
               for (i=0;i<8;i++) {
                  if (pieza(tablero,x,y,i,1)==JUGADOR) jaque |= 0x03;
               }
            break;
            case 0x12:
               for (i=0;i<8;i++) {
                  if (pieza(tablero,x,y,i,8)==JUGADOR) jaque |=0x01;
               }
            break;
         }
      }
      x++;
      y+=x/8;
      x%=8;
   }
   return (jaque);
}


void init (char **tablero) {
   int x, y;
   for (y=0;y<8;y++)
      for (x=0;x<8;x++)
         tablero[x][y]=0;
   tablero[4][4]=JUGADOR;
   x=0; y=0;
   tablero[x][y]=0;
   do {
      x=random(8);
      y=random(8);
   } while (tablero[x][y]);
   tablero[x][y]=REY;
   while (tablero[x][y]!=0) {
      x=random(8);
      y=random(8);
   }
   tablero[x][y]=0;
   do {
      x=random(8);
      y=random(8);
   } while (tablero[x][y]);
   tablero[x][y]=REINA;
}


int direccion (int ox, int oy, int dx, int dy) {
   int i, dist;
   dist= MAX(abs(dx-ox),abs(dy-oy));
   for (i=0;i<8;i++)
      if (ox+dist*desp[i][0]==dx && oy+dist*desp[i][1]==dy) return i;
   return -1;
}


char pieza(char **tablero, int ox, int oy, int direcc, int dist) {
  int i, x, y, seguir;
  seguir=1; i=0;
  x=ox; y=oy;
  while (seguir) {
     i++;
     x+=desp[direcc][0];
     y+=desp[direcc][1];
     if (x>7 || x<0 || y>7 || y<0 || i>dist) seguir=0;
     else {
        if (tablero[x][y]) return (tablero[x][y]);
     }
  }
  return 0;
}


int jugar(char **tablero) {
   int i, j;

   redraw(tablero);
   while (!mate(tablero)) {
      if (!mover_jugador(tablero)) return 1;
      redraw (tablero);
      deb=0;
      if (!mover_maquina(tablero,MUEVE | PROFUNDIDAD)) return 2;
      redraw (tablero);
      //printf ("\nEjecutadas %u jugadas",deb);getch();
   }
   return 2;
}

int mover_jugador(char **tablero) {
   int x,y,nx,ny,fin,movim;
   char car, bkppieza;

   fin=0;
   x=0; y=0;
   while (tablero[x][y]!=JUGADOR) {
      x++;
      y+=x/8;
      x%=8;
   }
   ultima[2]=x; ultima[3]=y;
   while (!fin) {
      car=getch();
      movim=-1;
      if (car==27) fin=1;
      else if (car==0) {
         car=getch();
         if (car=='H') movim=0;
         else if (car=='I') movim=1;
         else if (car=='M') movim=2;
         else if (car=='Q') movim=3;
         else if (car=='P') movim=4;
         else if (car=='O') movim=5;
         else if (car=='K') movim=6;
         else if (car=='G') movim=7;
      }
      if (movim>-1) {
         if (mueve (tablero,x,y,x+desp[movim][0],y+desp[movim][1],0)) {
            if (x+desp[movim][0]==ultima[0] && y+desp[movim][1]==ultima[1]) ultima[4]++; else ultima[4]=0;
            ultima[0]=ultima[2]; ultima[1]=ultima[3];
            return 1;
         }
      }
   }
   return 0;
}


int puntua(char **tablero) {
   int i, x, y, nx, ny, puntuacion, dist, bkppieza, maxp;
   int nummovs, mvx, mvy;

   x=0; y=0;
   while (tablero[x][y]!=JUGADOR) {
      x++;
      y+=x/8;
      x%=8;
   }
   maxp=0; nummovs=0;
   for (i=0;i<8;i++) {
      nx=x+desp[i][0];
      ny=y+desp[i][1];
      if (nx>=0 && nx<8 && ny>=0 && ny<8) {
         tablero[x][y]=0;
         bkppieza=tablero[nx][ny];
         tablero[nx][ny]=JUGADOR;
         if (!jaque(tablero)) {
            nummovs++;
            mvx=nx;mvy=ny;
            dist=(MIN(nx,7-nx)+MIN(ny,7-ny)+1)*3;
            puntuacion=(2*dist+6*distancia(tablero,REY));
            if ((ultima[0]==ultima[1] && (ultima[0]==7 || ultima[0]==0)) || ((ultima[0]+ultima[1]==7) && (ultima[0]==0 || ultima[0]==7))) puntuacion+=20*distancia(tablero,REY);
            if (nx==ultima[0] && ny==ultima[1]) puntuacion+=ultima[4];
            if (puntuacion>maxp) maxp=puntuacion;
            if (bkppieza) maxp=500;
         }
         tablero[x][y]=JUGADOR;
         tablero[nx][ny]=bkppieza;
      }
   }
   if (maxp==0) {
      if (jaque(tablero)==1) maxp=-500;
      else maxp=500;
   }
   if (nummovs==1 && mvx==ultima[0] && mvy==ultima[1]) maxp=500;
   return(maxp);
}


int mover_maquina(char **tablero, int depth) {
   int i, j, x,y,nx,ny,fin,movim;
   int kx ,ky, nkx, nky, r, bkprpieza; 
   int ox, oy, dx, dy, punt, mejorpunt, localpunt, dir;
   char car, bkppieza;

   kx=0; ky=0;
   while (tablero[kx][ky]!=JUGADOR) {
      kx++; ky+=kx/8; kx%=8;
   }

   x=0; y=0;
   mejorpunt=10000;
   while (y<8) {
      if (tablero[x][y] & 0x10) {
         switch (tablero[x][y]) {
            case REY:
               for (i=0;i<8;i++) {
                  nx=x+desp[i][0];
                  ny=y+desp[i][1];
                  if (mueve(tablero,x,y,nx,ny,1)) {
                     tablero[x][y]=0;
                     bkppieza=tablero[nx][ny];
                     tablero[nx][ny]=REY;
                     if (depth & 0x7F) {
                        deb++;
                        if (!(jaque(tablero) & 0x02)) {
                           punt=puntua(tablero);
                           if (punt<-500) punt*=((depth & 0x7F)+1);
                           if (punt<mejorpunt) {
                              mejorpunt=punt;
                              ox=x; oy=y; dx=nx; dy=ny;
                           }
                           if (punt<10) {
                              localpunt=-10000;
                              for (r=0;r<8;r++) {
                                 nkx=kx+desp[r][0];
                                 nky=ky+desp[r][1];
                                 bkprpieza=tablero[nkx][nky];
                                 tablero[kx][ky]=0;
                                 tablero[nkx][nky]=JUGADOR;
                                 if (jaque(tablero)!=1) {
                                    //redraw(tablero);
                                    //getch();
                                    punt=mover_maquina(tablero,(depth & 0x7F)-1);
                                    if (punt>localpunt) localpunt=punt;
                                 }
                                 tablero[kx][ky]=JUGADOR;
                                 tablero[nkx][nky]=bkprpieza;
                              }
                              if (localpunt<mejorpunt) {
                                 mejorpunt=localpunt;
                                 ox=x;oy=y;dx=nx;dy=ny;
                              }
                           }
                        }
                     }
                     else {
                        if (!(jaque(tablero) & 0x02)) punt=puntua(tablero);
                        deb++;
                        if (punt<mejorpunt) {
                           mejorpunt=punt;
                           //if (mejorpunt<0) { printf ("EHH 3, %d",punt); getch(); }
                           ox=x; oy=y; dx=nx; dy=ny;
                        }
                     }
                     tablero[x][y]=REY;
                     tablero[nx][ny]=bkppieza;
                  }
               }
            break;
            case REINA:
               for (j=0;j<8;j++) {
                  for (i=0;i<8;i++) {
                     nx=x+desp[i][0]*j;
                     ny=y+desp[i][1]*j;
                     if (mueve(tablero,x,y,nx,ny,1)) {
                        tablero[x][y]=0;
                        bkppieza=tablero[nx][ny];
                        tablero[nx][ny]=REINA;
                        if (depth & 0x7F) {
                           deb++;
                           if (!(jaque(tablero) & 0x02)) {
                              punt=puntua(tablero);
                              if (punt<-500) punt*=((depth & 0x7F)+1);
                              if (punt<mejorpunt) {
                                 mejorpunt=punt;
                                 ox=x; oy=y; dx=nx; dy=ny;
                              }
                              if (punt<10) {
                                 localpunt=-10000;
                                 for (r=0;r<8;r++) {
                                    nkx=kx+desp[r][0];
                                    nky=ky+desp[r][1];
                                    bkprpieza=tablero[nkx][nky];
                                    tablero[kx][ky]=0;
                                    tablero[nkx][nky]=JUGADOR;
                                    if (jaque(tablero)!=1) {
                                        //redraw(tablero);
                                        //getch();
                                        punt=mover_maquina(tablero,(depth & 0x7F)-1);
                                        if (punt>localpunt) localpunt=punt;
                                    }
                                    tablero[kx][ky]=JUGADOR;
                                    tablero[nkx][nky]=bkprpieza;
                                 }
                                 if (localpunt<mejorpunt) {
                                    mejorpunt=localpunt;
                                    ox=x;oy=y;dx=nx;dy=ny;
                                 }
                              }
                           }
                        }
                        else {
                           if (!(jaque(tablero) & 0x02)) punt=puntua(tablero);
                           deb++;
                           if (punt<mejorpunt) {
                              mejorpunt=punt;
                              //if (mejorpunt<0) { printf ("EHH 6, %d",punt); getch(); }
                              ox=x; oy=y; dx=nx; dy=ny;
                           }
                        }
                        tablero[x][y]=REINA;
                        tablero[nx][ny]=bkppieza;
                     }
                  }
               }
            break;
         }  
      }
      x++;
      y+=x/8;
      x%=8;
   }

   if (depth & 0x80) {
       mueve (tablero, ox,oy,dx,dy,0);
       gotoxy (5,22);
       //printf ("El movimiento mejor puntuado es (%d,%d)->(%d,%d) con %d\n",ox,oy,dx,dy,mejorpunt);
       //getch();
       return 1;
   }
   else  return mejorpunt;
}


int distancia (char **tablero, char ficha) {
   int x, y, xrey, yrey, xf, yf, dist;
   x=0; y=0;
   while (y<8) {
      if (tablero[x][y]==ficha) {
         xf=x; yf=y;
      }
      if (tablero[x][y]==JUGADOR) {
         xrey=x; yrey=y;
      }
      x++;
      y+=x/8;
      x%=8;
   }
   dist=MAX(abs(xf-xrey),abs(yf-yrey));
   //dist=(int)sqrt(pow((double)abs(xf-xrey),2)+pow((double)abs(yf-yrey),2));
   return (dist);
}

/*
void redraw (char **tablero) {
   int x,y;

   clrscr();
   printf ("\n\n\n");
   textcolor (3);
   cprintf ("                Ŀ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                Ĵ\n\r");
   cprintf ("                                        \n\r");
   cprintf ("                \n\r");
   x=0;y=0;
   while (y<8) {
      if (tablero[x][y] & 0x10) textcolor(4);
      else if (mate(tablero)) textcolor(3+128);
      else textcolor(3);
      switch (tablero[x][y] & 0x0F) {
         case 0x01:
         gotoxy (x*4+19,y*2+5);
         cprintf ("K");
         break;
         case 0x02:
         gotoxy (x*4+19,y*2+5);
         cprintf ("Q");
         break;
      }
      x++;
      y+=x/8;
      x%=8;
   }
   if (jaque(tablero) & 1) {
      gotoxy(30,23);
      textcolor(12);
      cprintf("JAQUE");
   }
   if (mate(tablero)) {
      gotoxy(30,23);
      textcolor(12);
      cprintf("JAQUE MATE");
      sleep(4);
      gotoxy(25,23);
      cprintf("  G A M E   O V E R");
      sleep(4);
   }
}
*/


void redraw(char **tablero) {
   int x=0, y=0, i;
   int xs=70, ys=10;

   setmem(pantalla,64000,0);
   while (y<8) {
      cuadro_v_screen(x*20+xs,y*16+ys,x*20+19+xs,y*16+15+ys,101+149*((y+x)%2),pantalla);
      switch (tablero[x][y]) {
         case JUGADOR:
            putover_v_screen(x*20+xs,y*16+ys,jugador,pantalla);
         break;
         case REY:
            putover_v_screen(x*20+xs,y*16+ys,rey,pantalla);
         break;
         case REINA:
            putover_v_screen(x*20+xs,y*16+ys,reina,pantalla);
         break;
      }
      x++; y+=x/8; x%=8;
   }

   if (mate(tablero)) {
      x=0; y=0;
      while (tablero[x][y]!=JUGADOR) { x++; y+=x/8; x%=8;}
      vprintxyf(pantalla,fuente,110,150,"JAQUE MATE",228);
      for (i=0; i<10; i++) {
         cuadro_v_screen(x*20+xs,y*16+ys,x*20+19+xs,y*16+15+ys,101+149*((y+x)%2),pantalla);
         draw_v_screen(pantalla);
         delay(200);
         putover_v_screen(x*20+xs,y*16+ys,jugador,pantalla);
         draw_v_screen(pantalla);
         delay(200);
      }
      cuadro_v_screen(0,150,320,158,0,pantalla);
      vprintxyf(pantalla,fuente,90,150,"G A M E   O V E R",228);
      for (i=0; i<10; i++) {
         cuadro_v_screen(x*20+xs,y*16+ys,x*20+19+xs,y*16+15+ys,101+149*((y+x)%2),pantalla);
         draw_v_screen(pantalla);
         delay(200);
         putover_v_screen(x*20+xs,y*16+ys,jugador,pantalla);
         draw_v_screen(pantalla);
         delay(200);
      }
      fadeout(0);
   }

   if (jaque(tablero) & 0x01) vprintxyf(pantalla,fuente,130,150,"JAQUE",228);
   draw_v_screen(pantalla);
}


int mate (char **tablero) {

   int i, x, y, nx, ny, bkpieza;

   if (jaque(tablero)==1) {
      x=0; y=0;
      while (tablero[x][y]!=JUGADOR) {
         x++; y+=x/8; x%=8;
      }
      tablero[x][y]=0;
      for (i=0;i<8;i++) {
         nx=x+desp[i][0];
         ny=y+desp[i][1];
         if (nx>=0 && nx<8 && ny>=0 && ny<8) {
            bkpieza=tablero[nx][ny];
            tablero[nx][ny]=JUGADOR;
            if (!(jaque(tablero) & 0x01)) {
               tablero[nx][ny]=bkpieza;
               tablero[x][y]=JUGADOR;
               return 0;
            }
            tablero[nx][ny]=bkpieza;
         }
      }
      tablero[x][y]=JUGADOR;
      return 1;
   }
   return 0;
}


void extractimg (char *src, char *dst, int x, int y, int tx, int ty) {
   int i, tamx;

   tamx=*((int *)src);
   *dst=tx & 0x00FF;
   *(dst+1)=tx>>8;
   *(dst+2)=ty & 0x0FF;
   *(dst+3)=ty>>8;
   for (i=0;i<ty;i++) {
      memcpy (dst+4+tx*i, src+4+tamx*(y+i)+x, tx);
   }
}


void vprintxyf(char *pantalla, char *fnt, int x, int y, char *texto, int color) {
   int rep=0;
   int r1, r2;
   int dx, dy, dc;
   while (*(texto+rep)) {
      for (r2=0;r2<8;r2++)
         for (r1=0;r1<8;r1++)
            if (*(fnt+*(texto+rep)*8+r2) & (1<<(7-r1))) *(pantalla+(y+r2)*320+x+8*rep+r1)=color;
      rep++;
   }
}
