#include <dos.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include <math.h>
#include <mem.h>

#define MIN(x1, x2) ((x2>x1) ? x1 : x2)
#define MAX(x1, x2) ((x2>x1) ? x2 : x1)

unsigned char colorpal[3*256];

void cuadro_v_screen (int x1, int y1, int x2, int y2, int color, char *pantalla);
void putover_v_screen (int x, int y, char *store, char *pantalla);
void draw_v_screen(char *pantalla);
void putover (int x, int y, char *store);
int setpalette(char *);
unsigned int imgsize(int x1, int y1, int x2, int y2);
int fadeout(int color);


void cuadro_v_screen (int x1, int y1, int x2, int y2, int color, char *pantalla) {
int bucle1, bucle2;
for (bucle2=y1; bucle2<=y2; bucle2++) {
   for (bucle1=x1; bucle1<=x2; bucle1++) {
      *(pantalla+320*bucle2+bucle1)=color;
   }
}
}

void putover (int x, int y, char *store) {
char *memoria_grafica=(char *)0xA0000000;
int *temporal=(int *)store;
int bucle1, bucle2, num1, num2, color_a_poner;
long desplazamiento=0;
num1=*temporal; num2=*(temporal+1);
for (bucle2=y; bucle2<y+num2; bucle2++) {
   for (bucle1=x; bucle1<x+num1; bucle1++) {
      color_a_poner=*(store+desplazamiento+4);
      if (color_a_poner) *(memoria_grafica+320*bucle2+bucle1)=color_a_poner;
      desplazamiento++;
   }
}
}


unsigned int imgsize(int x1, int y1, int x2, int y2) {
return ((y2-y1)*(x2-x1)+5);
}



setpalette (char *paleta) {
int desp;
for (desp=0; desp<768; desp++) {
   colorpal [desp]=*(paleta+desp);
}
asm {
   mov   ax, SEG colorpal      // get segment of palette
   mov   es, ax
   mov   dx, OFFSET colorpal   // get offset of palette
   mov   bx, 0                 // start with color # 0
   mov   cx, 256               // load 256 colors
   mov   ax, 0x1012            // bios function 10 subfunction 12
   int   0x10                  // call bios to load palette
}
return 0;
}


void putover_v_screen (int x, int y, char *store, char *pantalla) {
int *temporal=(int *)store;
int bucle1, bucle2, num1, num2, color_a_poner;
long desplazamiento=0;
num1=*temporal; num2=*(temporal+1);
for (bucle2=y; bucle2<y+num2; bucle2++) {
   for (bucle1=x; bucle1<x+num1; bucle1++) {
      color_a_poner=*(store+desplazamiento+4);
      if (color_a_poner) *(pantalla+320*bucle2+bucle1)=color_a_poner;
      desplazamiento++;
   }
}
}




void draw_v_screen(char *pantalla) {
   memcpy ((char *)0xA0000000, pantalla, 64000);
}



int fadeout(int color) {
unsigned char *pal;
double *paleta;
unsigned char comp[3];
unsigned int rep, rep2;
outp (0x03c7,color);
comp[0]=inp(0x03c9);
comp[1]=inp(0x03c9);
comp[2]=inp(0x03c9);
if (!(paleta=(double *)malloc(768*sizeof(double)))) {return 0;}
if (!(pal=(char *)malloc(768))) return 0;
for (rep=0;rep<256;rep++) {
   outp(0x03c7,rep);
   pal[rep*3]=inp(0x03c9);
   pal[rep*3+1]=inp(0x03c9);
   pal[rep*3+2]=inp(0x03c9);
}
for (rep=0;rep<768;rep++) paleta[rep]=(double)pal[rep];
for (rep2=0;rep2<101;rep2+=1) {
   for (rep=0;rep<256;rep++) {
      paleta[rep*3]=pal[rep*3]+(comp[0]-pal[rep*3])*((double)rep2/100);
      paleta[rep*3+1]=pal[rep*3+1]+(comp[1]-pal[rep*3+1])*((double)rep2/100);
      paleta[rep*3+2]=pal[rep*3+2]+(comp[2]-pal[rep*3+2])*((double)rep2/100);
    }
   for (rep=0;rep<256;rep++) {
      outp(0x03c8,rep);
      outp(0x03c9,(unsigned char)paleta[rep*3]);
      outp(0x03c9,(unsigned char)paleta[rep*3+1]);
      outp(0x03c9,(unsigned char)paleta[rep*3+2]);
   }
   delay(15);
}
for (rep=0;rep<256;rep++) {
   outp(0x03c8,rep);
   outp(0x03c9,comp[0]);
   outp(0x03c9,comp[1]);
   outp(0x03c9,comp[2]);
}
for (rep=0;rep<64000;rep++) *((char *)0xA0000000+rep)=color;
for (rep=0;rep<256;rep++) {
   outp(0x03c8,rep);
   outp(0x03c9,pal[rep*3]);
   outp(0x03c9,pal[rep*3+1]);
   outp(0x03c9,pal[rep*3+2]);
}
return 1;
}


